diff --git a/linux-2.6.37.6-antonio/ipc/stm_quiesce.h b/linux-2.6.37.6-antonio/ipc/stm_quiesce.h
new file mode 100644
index 0000000..2a27b1a
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm_quiesce.h
@@ -0,0 +1,331 @@
+/*
+ * stm_quiesce.h
+ *
+ *  Created on: Jan 4, 2012
+ *      Author: root
+ */
+
+#ifndef STM_QUIESCE_H_
+#define STM_QUIESCE_H_
+
+// this is something similar to the global run queue lock
+//a list of threads are managed
+
+// RFC from Chris Simmonds
+#include <linux/wait.h>
+#include <linux/mutex.h>
+static void cond_wait (wait_queue_head_t *wq, struct mutex *mutex)
+{
+	DEFINE_WAIT(__wait);
+
+	prepare_to_wait(wq, &__wait, TASK_UNINTERRUPTIBLE);
+	mutex_unlock (mutex);
+	schedule();
+	mutex_lock (mutex);
+	finish_wait(wq, &__wait);
+}
+#define cond_signal(wq) wake_up(wq)
+#define cond_broadcast(wq) wake_up_all(wq)
+
+/**
+ * cond_wait_interruptible - wait for a condition variable
+ * @wq: the wait queue to wait on
+ * @mutex: a locked mutex
+ *
+ * Safely put the calling task into an interruptible sleep on the
+ * wait queue then unlock the mutex. Re-acquire the mutex after waking up
+ */
+int cond_wait_interruptible (wait_queue_head_t *wq, struct mutex *mutex)
+{
+ int ret = 0;
+ DEFINE_WAIT(__wait);
+
+ prepare_to_wait(wq, &__wait, TASK_INTERRUPTIBLE);
+ mutex_unlock (mutex);
+ if (signal_pending(current))
+ ret = -ERESTARTSYS;
+ else
+ schedule();
+ mutex_lock (mutex);
+ finish_wait(wq, &__wait);
+ return ret;
+}
+#define cond_signal_interruptible(wq) wake_up_interruptible(wq)
+#define cond_broadcast_interruptible(wq) wake_up_interruptible_all(wq)
+
+/**
+ * cond_wait_spinlock - wait for a condition variable
+ * @wq: the wait queue to wait on
+ * @sl: a locked spinlock
+ *
+ * Safely put the calling task into an interruptible sleep on the
+ * wait queue then unlock the spinlock. Re-acquire after waking up
+ */
+void cond_wait_spinlock (wait_queue_head_t *wq, spinlock_t *sl)
+{
+ DEFINE_WAIT(__wait);
+
+ prepare_to_wait(wq, &__wait, TASK_UNINTERRUPTIBLE);
+ spin_unlock (sl);
+ schedule();
+ spin_lock (sl);
+ finish_wait(wq, &__wait);
+}
+
+/**
+ * cond_wait_spinlock_irq - wait for a condition variable
+ * @wq: the wait queue to wait on
+ * @sl: a locked spinlock
+ *
+ * Safely put the calling task into an interruptible sleep on the
+ * wait queue then unlock the spinlock and enable irqs. Re-acquire
+ * spinlock and disable irqs after waking up
+ */
+void cond_wait_spinlock_irq (wait_queue_head_t *wq, spinlock_t *sl)
+{
+ DEFINE_WAIT(__wait);
+
+ prepare_to_wait(wq, &__wait, TASK_UNINTERRUPTIBLE);
+ spin_unlock_irq (sl);
+ schedule();
+ spin_lock_irq (sl);
+ finish_wait(wq, &__wait);
+}
+
+//WAS pthread_mutex_t quiesce_mutex;          /* Mutex to support quiescence */
+struct mutex quiesce_mutex;
+//WAS pthread_cond_t quiesce_cond;            /* Condition variable to support quiescence */
+wait_queue_head_t quiesce_cond;
+
+volatile stm_word_t quiesce;            /* Prevent threads from entering transactions upon quiescence */
+volatile stm_word_t threads_count;      /* Number of active threads */
+stm_tx_t *threads;                      /* Head of linked list of threads */
+
+/*
+ * Initialize quiescence support.
+ */
+static inline void stm_quiesce_init(void)
+{
+  PRINT_DEBUG("==> stm_quiesce_init()\n");
+
+/*  if (pthread_mutex_init(&quiesce_mutex, NULL) != 0) {
+    PRINT_ERR( "Error creating mutex\n");
+    exit(1);
+  }
+*/ //in kernel the mutex will be init in unlocked state (void return)
+  mutex_init(&quiesce_mutex);
+
+/*
+  if (pthread_cond_init(&quiesce_cond, NULL) != 0) {
+    PRINT_ERR( "Error creating condition variable\n");
+    exit(1);
+  }
+*/ //in kernel wait queue
+  init_waitqueue_head(&quiesce_cond);
+
+  quiesce = 0;
+  threads_count = 0;
+  threads = NULL;
+}
+
+/*
+ * Clean up quiescence support.
+ */
+static inline void stm_quiesce_exit(void)
+{
+  PRINT_DEBUG("==> stm_quiesce_exit()\n");
+
+// WAS  thread_cond_destroy(&quiesce_cond);
+  // TODOdestroy wait queue
+
+   // WASpthread_mutex_destroy(&quiesce_mutex);
+  mutex_destroy(&quiesce_mutex);
+}
+
+/*
+ * Called by each thread upon initialization for quiescence support.
+ */
+static inline void stm_quiesce_enter_thread(stm_tx_t *tx)
+{
+  PRINT_DEBUG("==> stm_quiesce_enter_thread(%p)\n", tx);
+
+// WAS  pthread_mutex_lock(&quiesce_mutex);
+  mutex_lock(&quiesce_mutex);
+  /* Add new descriptor at head of list */
+  tx->next = threads;
+  threads = tx;
+  threads_count++;
+//WAS  pthread_mutex_unlock(&quiesce_mutex);
+  mutex_unlock(&quiesce_mutex);
+
+}
+
+/*
+ * Called by each thread upon exit for quiescence support.
+ */
+static inline void stm_quiesce_exit_thread(stm_tx_t *tx)
+{
+  stm_tx_t *t, *p;
+
+  PRINT_DEBUG("==> stm_quiesce_exit_thread(%p)\n", tx);
+
+  /* Can only be called if non-active */
+  assert(!IS_ACTIVE(tx->status));
+
+//WAS pthread_mutex_lock(&quiesce_mutex);
+  mutex_lock(&quiesce_mutex);
+  /* Remove descriptor from list */
+  p = NULL;
+  t = threads;
+  while (t != tx) {
+    assert(t != NULL);
+    p = t;
+    t = t->next;
+  }
+  if (p == NULL)
+    threads = t->next;
+  else
+    p->next = t->next;
+  threads_count--;
+  if (quiesce) {
+    /* Wake up someone in case other threads are waiting for us */
+//WAS   pthread_cond_signal(&quiesce_cond);
+	  cond_signal(&quiesce_cond);
+  }
+//WAS  pthread_mutex_unlock(&quiesce_mutex);
+  mutex_unlock(&quiesce_mutex);
+}
+
+/*
+ * Wait for all transactions to be block on a barrier.
+ */
+static inline void stm_quiesce_barrier(stm_tx_t *tx, void (*f)(void *), void *arg)
+{
+  PRINT_DEBUG("==> stm_quiesce_barrier()\n");
+
+  /* Can only be called if non-active */
+  assert(tx == NULL || !IS_ACTIVE(tx->status));
+
+//WAS  pthread_mutex_lock(&quiesce_mutex);
+  mutex_lock(&quiesce_mutex);
+  /* Wait for all other transactions to block on barrier */
+  threads_count--;
+  if (quiesce == 0) {
+    /* We are first on the barrier */
+    quiesce = 1;
+  }
+  while (quiesce) {
+    if (threads_count == 0) {
+      /* Everybody is blocked */
+      if (f != NULL)
+        f(arg);
+      /* Release transactional threads */
+      quiesce = 0;
+  //WAS    pthread_cond_broadcast(&quiesce_cond);
+      cond_broadcast(&quiesce_cond);
+    } else {
+      /* Wait for other transactions to stop */
+  //WAS    pthread_cond_wait(&quiesce_cond, &quiesce_mutex);
+    	cond_wait( &quiesce_cond, &quiesce_mutex);
+    }
+  }
+  threads_count++;
+//WAS  pthread_mutex_unlock(&quiesce_mutex);
+  mutex_unlock(&quiesce_mutex);
+}
+
+/*
+ * Wait for all transactions to be be out of their current transaction.
+ */
+static inline int stm_quiesce(stm_tx_t *tx, int block)
+{
+  stm_tx_t *t;
+#if CM == CM_MODULAR
+  stm_word_t s, c;
+#endif /* CM == CM_MODULAR */
+
+  PRINT_DEBUG("==> stm_quiesce(%p)\n", tx);
+
+  if (IS_ACTIVE(tx->status)) {
+    /* Only one active transaction can quiesce at a time, others must abort */
+// WAS   if (pthread_mutex_trylock(&quiesce_mutex) != 0)
+	  if (mutex_trylock(&quiesce_mutex) != 0)
+		  return 1;
+  } else {
+    // We can safely block because we are inactive
+//WAS    pthread_mutex_lock(&quiesce_mutex);
+	    mutex_lock(&quiesce_mutex);
+  }
+  /* We own the lock at this point */
+  if (block)
+    ATOMIC_STORE_REL(&quiesce, 2);
+  /* Make sure we read latest status data */
+  ATOMIC_MB_FULL;
+  /* Not optimal as we check transaction sequentially and might miss some inactivity states */
+  for (t = threads; t != NULL; t = t->next) {
+    if (t == tx)
+      continue;
+    /* Wait for all other transactions to become inactive */
+#if CM == CM_MODULAR
+    s = t->status;
+    if (IS_ACTIVE(s)) {
+      c = GET_STATUS_COUNTER(s);
+      do {
+        s = t->status;
+      } while (IS_ACTIVE(s) && c == GET_STATUS_COUNTER(s));
+    }
+#else /* CM != CM_MODULAR */
+    while (IS_ACTIVE(t->status))
+      ;
+#endif /* CM != CM_MODULAR */
+  }
+  if (!block)
+//WAS    pthread_mutex_unlock(&quiesce_mutex);
+	    mutex_unlock(&quiesce_mutex);
+  return 0;
+}
+
+/*
+ * Check if transaction must block.
+ */
+static inline int stm_check_quiesce(stm_tx_t * tx)
+{
+  stm_word_t s;
+
+  /* Must be called upon start (while already active but before acquiring any lock) */
+  assert(IS_ACTIVE(tx->status));
+
+#ifdef IRREVOCABLE_ENABLED
+  if ((tx->irrevocable & 0x08) != 0) {
+    /* Serial irrevocable mode: we are executing alone */
+    return 0;
+  }
+#endif
+  ATOMIC_MB_FULL;
+  if (ATOMIC_LOAD_ACQ(&quiesce) == 2) {
+    s = ATOMIC_LOAD(&tx->status);
+    SET_STATUS(tx->status, TX_IDLE);
+    while (ATOMIC_LOAD_ACQ(&quiesce) == 2) {
+#ifdef WAIT_YIELD
+//      sched_yield();
+    	schedule();
+#endif /* WAIT_YIELD */
+    }
+    SET_STATUS(tx->status, GET_STATUS(s));
+    return 1;
+  }
+  return 0;
+}
+
+/*
+ * Release threads blocked after quiescence.
+ */
+static inline void stm_quiesce_release(stm_tx_t *tx)
+{
+  ATOMIC_STORE_REL(&quiesce, 0);
+// WAS  pthread_mutex_unlock(&quiesce_mutex);
+  mutex_unlock(&quiesce_mutex);
+}
+
+
+#endif /* STM_QUIESCE_H_ */
diff --git a/linux-2.6.37.6-antonio/ipc/stm_syscall.h b/linux-2.6.37.6-antonio/ipc/stm_syscall.h
new file mode 100644
index 0000000..ced960a
--- /dev/null
+++ b/linux-2.6.37.6-antonio/ipc/stm_syscall.h
@@ -0,0 +1,294 @@
+/*
+ * stm_syscall.h
+ *
+ *  Created on: Jan 6, 2012
+ *      Author: Antonio Barbalace
+ *
+ * common syscall entry code for stm
+ */
+
+#ifndef STM_SYSCALL_H_
+#define STM_SYSCALL_H_
+
+#include <linux/syscalls.h>
+#include <linux/uaccess.h>
+
+#include <linux/snapshot.h>
+
+
+//che dati mi servono ?!?!
+//call_id, i.e. STM_START, STM_COMMIT, STM_ABORT, STM_LOAD, STM_STORE
+//stack_addr
+//stack_size
+
+//function arguments.. (TXPARAM) +
+//STM_START stm_tx_attr_t
+//STM_COMMIT
+//STM_ABORT reason
+//STM_LOAD stm_word_t*
+//STM_STORE stm_word_t* stm_word_t
+
+//START common user/krn definitions
+//flags can be mixed with func_num
+
+#define SYS_STM_INIT_THREAD	0x008000
+#define SYS_STM_EXIT_THREAD	0x008800
+
+#define SYS_STM_START 		0x008100
+#define SYS_STM_COMMIT		0x008200
+#define SYS_STM_ABORT		0x008400
+//io functions
+#define SYS_STM_LOAD		0x810000
+#define SYS_STM_STORE		0x820000
+
+// generic functions
+#define SYS_STM_GET_STAT		0x81000000
+#define SYS_STM_GET_STAT_GLOBAL	0x82000000
+#define SYS_STM_GET_STAT_LOCAL	0x84000000
+
+#define SYS_STM_GET_PARAM		0x88000000
+
+#define SYS_STM_SPEC_CREATE		0x41000000
+#define SYS_STM_SPEC_SET		0x42000000
+#define SYS_STM_SPEC_GET		0x44000000
+
+//stm_attr_t must be define before (include /include/linux/stm_types.h)
+typedef struct __stack_desc {
+	void * addr;
+	int size;
+//	int index;
+//	long flags;
+} stack_desc;
+
+typedef struct __io_desc {
+	stm_word_t * address;
+	stm_word_t value;
+} io_desc;
+
+typedef struct __spec_desc {
+	int key;
+	void *data;
+} spec_desc;
+
+#define STM_GET_CAP_MAX 64
+
+typedef union __func_desc {
+	stm_tx_attr_t attr;
+	io_desc io;
+	spec_desc spec;
+	int reason; // abort
+	unsigned long value; // stats and param
+	char info[STM_GET_CAP_MAX]; // stats and param
+} func_desc;
+//END
+
+//The data in chk_pnt are data decided by the stm_ interface (flags is the kind of
+//of snapshot and index is the snashot handler that wll be saved in the thread_tx struct)
+// syscall 3 args +ptregs
+
+// only STM_START needs stack_desc the other functions does not require it!
+
+int sys_stm_ctrl (int fnum, func_desc * fdesc, stack_desc * sdesc, struct pt_regs *regs)
+{
+	int ret = 0;
+	func_desc krnfdesc;
+	stack_desc krnsdesc;
+
+	memset((void*) &krnfdesc, 0, sizeof(func_desc));
+	memset((void*) &krnsdesc, 0, sizeof(stack_desc));
+
+//	printk("%s: fnum %d fdesc %p sdesc %p pt_regs %p\n",
+//			__func__, fnum, fdesc, sdesc,regs);
+
+///////////////////////////////////////////////////////////////////////////////
+// copy the two descriptors from user space and if ok make the switch between operations
+///////////////////////////////////////////////////////////////////////////////
+	//check user address before access -> done by copy_from_user .. __must_ch
+	if (fdesc) { // if this is zero we cannot return index data and read flag data
+		// return bytes that cannot be copied
+		if ( (ret = __copy_from_user_inatomic(&krnfdesc, fdesc, sizeof(func_desc))) )
+			printk("%s: error retrieving func_desc from user space ret %d sizeof %d addr %p\n",
+					__func__, ret, sizeof(func_desc), fdesc); // error
+	}
+	if (sdesc) { // if this is zero we cannot return index data and read flag data
+		// return bytes that cannot be copied
+		if ( (ret = __copy_from_user_inatomic(&krnsdesc, sdesc, sizeof(stack_desc))) )
+			printk("%s: error retrieving stack_desc from user space ret %d sizeof %d addr %p\n",
+					__func__, ret, sizeof(stack_desc), sdesc); // error
+	}
+
+///////////////////////////////////////////////////////////////////////////////
+// switch on required function number
+///////////////////////////////////////////////////////////////////////////////
+	switch (fnum)
+	{
+	case SYS_STM_INIT_THREAD: { // TODO error reporting add
+		current->thread_tx = stm_init_thread();
+		if (sdesc) {
+			current->thread_tx->stack.addr = krnsdesc.addr;
+			current->thread_tx->stack.size = krnsdesc.size;
+		}
+		break;
+	}
+	case SYS_STM_EXIT_THREAD: { // TODO error reporting add
+		if (current->thread_tx) {
+			stm_exit_thread(current->thread_tx);
+			current->thread_tx = 0;
+		}
+		break;
+	}
+	case SYS_STM_START: {
+		uintptr_t snp; // must be long on 64bit
+		if ( (snp = stm_start(&(krnfdesc.attr)) )!= NULL ) {
+/*			if (fdesc) {
+				user_data.index = krnsdesc.index;
+				user_data.flags = krnsdesc.flags;
+			}
+*/	//prev		if (sdesc) { // if stack descriptor is not passed by error
+				//*snp = (uintptr_t)create_snapshot(krnsdesc.addr, krnsdesc.size, 0, regs); //save the snapshot number in current->thread_tx
+// the snapshot parameters were passed every start transaction, the new version (to be more efficient will save them on the thread desc)
+//				snp = (uintptr_t)create_snapshot(krnsdesc.addr, krnsdesc.size, 0, regs); //save the snapshot number in current->thread_tx
+				snp = (uintptr_t)create_snapshot(current->thread_tx->stack.addr, current->thread_tx->stack.size, 0, regs); //save the snapshot number in current->thread_tx
+				//save the snapshot
+
+				// TODO
+				// if create_snapshot fails it returns zero, zero it's ok to be saved in snapshot
+				// consider the case when no snapshot is present you cannot simply rollback
+				// the transaction must be switch to irrevocable (error is signaled in dmesg by create_snapshot)
+				current->thread_tx->snapshot = snp;
+/*			}
+			else {
+				printk ("%s: stack descriptor is required from STM_START\n", __func__);
+				return -ENODEV;
+			}
+	*/	}
+		break; }
+	case SYS_STM_COMMIT: {
+		uintptr_t snp;
+		if (current->thread_tx->snapshot == 0) {
+			printk ("%s:stm_commit current (pid %d) has no registered transaction\n",
+					__func__, current->pid);
+			return -ENODEV; }
+		if ( (ret = stm_commit()) == ROLLBACK_REQUESTED ) {
+			// rollback user space state, snapshot can be invalid (dmesg error from restore_)
+			snp = restore_snapshot (current->thread_tx->snapshot, 0x00, regs);
+			return snp; //this return SUCCESS or ROLLBACK_NO_RETRY
+		}
+
+		// TODO
+		// on commit delete the checkpoint (this is true only on flat nesting)
+		delete_snapshot(current->thread_tx->snapshot, 0x00);
+		current->thread_tx->snapshot = 0;
+
+		return ret;
+		break; }
+	case SYS_STM_ABORT: {
+		uintptr_t snp;
+		if (current->thread_tx->snapshot == 0) {
+			printk ("%s:stm_abort current (pid %d) has no registered transaction\n",
+					__func__, current->pid);
+			return -ENODEV; }
+		if ( (ret = stm_abort(krnfdesc.reason)) == ROLLBACK_REQUESTED )
+			if (snp = restore_snapshot (current->thread_tx->snapshot, 0, regs) )
+				return krnfdesc.reason;
+		return ret;
+		break; }
+	case SYS_STM_LOAD: {
+		uintptr_t snp;
+		if (current->thread_tx->snapshot == 0) {
+			printk ("%s:stm_load current (pid %d) has no registered transaction\n",
+					__func__, current->pid);
+			return -ENODEV; }
+
+		stm_word_t value;
+		if ( (ret = stm_load (krnfdesc.io.address, &value)) == ROLLBACK_REQUESTED ) {
+			if (snp = restore_snapshot (current->thread_tx->snapshot, 0, regs) )
+				return 0; // TODO
+		}
+		if ( fdesc  && !put_user(value, &(fdesc->io.value)) ) // put_user returns 0 un success
+			return 0;
+		return value; // return value only on success
+		break;}
+	case SYS_STM_STORE: {  // word size store
+		uintptr_t snp;
+		if (current->thread_tx->snapshot == 0) {
+			printk ("%s:stm_store current (pid %d) has no registered transaction\n",
+					__func__, current->pid);
+			return -ENODEV; }
+
+		if ( (ret = stm_store (krnfdesc.io.address, krnfdesc.io.value)) == ROLLBACK_REQUESTED ) {
+			if (snp = restore_snapshot (current->thread_tx->snapshot, 0, regs) )
+		return ret;}
+		return krnfdesc.io.value;
+		break; }
+		// TODO in the future
+/*	case SYS_STM_STORE2: // part of word size ... probably is much better to always use store2
+
+		if ( (ret = stm_store2 (krnfdesc.io.address, krnfdesc.io.value)) == ROLLBACK_REQUESTED )
+//restore snapshot			sys_snapshot();
+		return ret;
+		break;
+*/
+	case SYS_STM_GET_STAT: {
+		unsigned long value;
+
+		ret =  stm_get_stats(&(krnfdesc.info), &value); // stm_get_stats fails with 0
+		// copy the value to user
+		//printk("stm_get_stats %s %ld %p\n", &(krnfdesc.info), value, &value);
+		if ( fdesc  && !put_user(value, &(fdesc->value)) ) // put_user returns 0 un success
+			return ret;
+		return 0; // we failed with the same error code 0 of stm_get_stats
+		break; }
+	case SYS_STM_GET_STAT_GLOBAL: {
+		unsigned long value;
+
+		ret =  stm_get_global_stats(&(krnfdesc.info), &value); // stm_get_stats fails with 0
+		// copy the value to user
+		if ( fdesc  && !put_user(value, &(fdesc->value)) ) // put_user returns 0 un success
+			return ret;
+		return 0; // we failed with the same error code 0 of stm_get_stats
+		break;}
+	case SYS_STM_GET_STAT_LOCAL: {
+		unsigned long value;
+
+		ret =  stm_get_local_stats(&(krnfdesc.info), &value); // stm_get_stats fails with 0
+		// copy the value to user
+		if ( fdesc  && !put_user(value, &(fdesc->value)) ) // put_user returns 0 un success
+			return ret;
+		return 0; // we failed with the same error code 0 of stm_get_stats
+		break;}
+	case SYS_STM_GET_PARAM: {
+		char buffer[STM_GET_CAP_MAX]; memset(buffer, 0, sizeof(buffer));
+
+		ret =  stm_get_parameter(&(krnfdesc.info), buffer); // fails with zero
+		// copy the value/array/struct to user
+		if ( fdesc && !copy_to_user( &(fdesc->info), buffer, sizeof(buffer)) )
+			return ret;
+		return 0; // we failed with the same error code 0 of stm_get_param
+		break; }
+
+	case SYS_STM_SPEC_CREATE: {
+		return stm_create_specific();
+	break; }
+	case SYS_STM_SPEC_SET: {
+		stm_set_specific(krnfdesc.spec.key, krnfdesc.spec.data);
+		return 0;
+	break; }
+	case SYS_STM_SPEC_GET: {
+		krnfdesc.spec.data = stm_get_specific(krnfdesc.spec.key);
+		put_user(krnfdesc.spec.data, &(fdesc->spec.data));
+		return 0;
+	break; }
+
+	default:
+	printk("%s: function not supported\n", __func__);
+	break;
+	}
+	return 0;
+}
+
+//IDEA for fasten stm IO it is possible to subdivide ctrl and io for each stm
+//this is something could be discussed for speed up devel we just use one syscall
+//sys_stm_io()
+
+#endif /* STM_SYSCALL_H_ */
diff --git a/linux-2.6.37.6-antonio/kernel/exit.c b/linux-2.6.37.6-antonio/kernel/exit.c
index 676149a..108881d 100644
--- a/linux-2.6.37.6-antonio/kernel/exit.c
+++ b/linux-2.6.37.6-antonio/kernel/exit.c
@@ -51,6 +51,7 @@
 #include <trace/events/sched.h>
 #include <linux/hw_breakpoint.h>
 #include <linux/oom.h>
+#include <linux/snapshot.h>
 
 #include <asm/uaccess.h>
 #include <asm/unistd.h>
@@ -949,6 +950,11 @@ NORET_TYPE void do_exit(long code)
 	}
 
 	exit_irq_thread();
+	// exit stm support
+//	stm_exit_thread(tsk->thread_tx);
+	tsk->thread_tx = 0;
+	// exit snapshot/checkpointing
+	exit_snapshot(tsk);
 
 	exit_signals(tsk);  /* sets PF_EXITING */
 	/*
